5894 字
约 19 分钟
7
26. 删除有序数组中的重复项
无标签

26. 删除有序数组中的重复项

作者:沉默王二
发布时间:2024-02-11T23:12:19.317+0800


今天夜游了珠江,广州塔的夜景还是很不错的,尤其是坐在三层,贵一点的体感和坐一楼完全不一样。这会写一道 LeetCode,再写一篇明天的文章,睡觉。技术派阅读地址:https://paicoding.com/column/7/26

  • 语雀专栏地址+密码可通过星球置顶帖查看:https://t.zsxq.com/15rEo9Pdu

  • 这道题可以说完全重写了,给出 2 道大家完全都能掌握的题解(双指针,数组基本操作)。

  • 增加代码注释,这样大家更容易看懂并掌握题解;

  • 增加参考资料,这样大家可以从零基础直接开刷,减轻新手刷题的阻力;

  • 增加手绘图,这样大家更容易理解解题思路;

  • 增加 ACM 输入输出,这样大家可以在 Intellij IDEA 中进行调试;

  • 增加题解模拟,这样大家可以根据题解模拟整个题解过程,看完会有一种“哦哦”恍然大悟的感觉;

  • 图片上传至 OSS 并配合 CDN,提升大家在技术派网站中的阅读体感。

  • 另外,这一版本会作为 PDF 的终稿随后在星球进行发布。

鲁迅说过,大年初二,人在广州,我仍然没有停止刷二哥的 LeetCode 刷题笔记,这是我对自己的交代,也是对你们的交代,我们一起加油!

题意

给你一个 非严格递增排列 的数组 nums ,请你 原地 删除重复出现的元素,使每个元素 只出现一次 ,返回删除后数组的新长度。元素的 相对顺序 应该保持 一致 。然后返回 nums 中唯一元素的个数。

考虑 nums 的唯一元素的数量为 k ,你需要做以下事情确保你的题解可以被通过:

  • 更改数组 nums ,使 nums 的前 k 个元素包含唯一元素,并按照它们最初在 nums 中出现的顺序排列。nums 的其余元素与 nums 的大小不重要。
  • 返回 k。

评判标准

系统会用下面的代码来测试你的题解:

int[] nums = [...]; // 输入数组

int k = removeDuplicates(nums); // 调用
assert k == expectedNums.length;for (int i = 0; i < k; i++) { assert nums[i] == expectedNums[i];}

如果所有断言都通过,那么您的题解将被 通过。

难度

简单

示例

输入:nums=[1,1,2]

解释:返回新数组的长度2,并且原数组nums的前两个元素被修改为1,2。不需要考虑数组中超出新长度后面的元素。
输入:nums=[0,0,1,1,1,2,2,3,3,4]输出:5,nums=[0,1,2,3,4]解释:方法应该返回新的长度5,并且原数组nums的前五个元素被修改为0,1,2,3,4。不需要考虑数组中超出新长度后面的元素。

分析

看完题目,我们要搞清楚几个事情:

  • 非严格递增排列
  • 原地删除重复出现的元素

非严格递增排序,其实就是传统意义上的升序排列,即nums[i] <= nums[i + 1]。只不过,确实是“非严格”,存在相等的情况,而不是 nums[i] < nums[i + 1]。

因为如果是严格递增排序的话,也就不存在重复元素了,😝

那什么是原地删除重复出现的元素呢?

"原地删除重复出现的元素"(In-place remove duplicates)是一种常见的算法策略,特别是在处理数组或线性数据结构时。

"原地"(In-place)操作意味着算法对数据的修改是直接在给定的数据结构上进行的,而不是使用额外的空间来创建数据的副本进行操作。

对于删除数组中的重复元素的操作来说,"原地"操作要求我们不使用额外的数组或集合来存储结果,而是直接在输入的数组上进行修改。

如果我们抛去原地操作这个限制,题解一般会这样写:

class Solution {
    int i = 0,j = 0;        // 创建一个新的数组        int[] res = new int[nums.length];        // 遍历原来的数组        for(;i < nums.length;i++) {            // 如果当前元素不等于下一个元素            if(nums[i] != nums[i + 1]) {                // 将当前元素放到新数组中                res[j++] = nums[i];            }        }        return j;    }

}

就 too simple 了!这道题也就没有存在的必要了。

那如何在原地进行修改呢?

其实也简单,我们用两个指针,一个指针 i 用来遍历数组,另一个指针 j 用来指向不重复的元素。

当 nums[i] 不等于 nums[j] 时,说明找到了一个新的不重复元素,此时将 j 指针向后移动一位,并将 nums[i] 的值复制到 nums[j]。这一步实际上是在更新当前不重复序列的下一个位置,并将新发现的不重复元素放在那里。

没错,就可以实现原地修改了!

class Solutions {
    int i = 0,j = 0;        for(;i < nums.length;i++)            if(nums[i] != nums[j])                nums[++j] = nums[i];        return j + 1;    }}

其实就是,把不重复的元素按照顺序放在数组的前面,然后返回不重复元素的个数,就搞定了。我们并没有关心 num 数组本身是什么样子。

比如说,nums = [0,0,1,1,1,2,2,3,3,4],nums 最后是 [0,1,2,3,4,2,2,3,3,4]。

大家可以通过 debug 的方式体验一下:

class Main02601 {
    Solutions02601 solutions = new Solutions02601();        int[] nums = {0,0,1,1,1,2,2,3,3,4};        int result = solutions.removeDuplicates(nums);        System.out.println(result);    }}

class Solutions02601 { public int removeDuplicates(int[] nums) { int i = 0,j = 0; for(;i < nums.length;i++) { if (nums[i] != nums[j]) { nums[++j] = nums[i]; } } return j + 1; }}

看一看是不是也很简单?效率也很不错。

总结

这道题其实没有考察别的东西,就是单纯的**数组 **操作,我们甚至可以换另外一种写法:

class Solution {
    // 如果数组为空,直接返回 0        if (nums.length == 0) return 0;        // 定义一个慢指针        int i = 0;        // j 为快指针,用来遍历数组        for (int j = 1; j < nums.length; j++) {            // 如果当前元素不等于下一个元素            if (nums[j] != nums[i]) {                // 移动慢指针                i++;                // 将当前元素复制到慢指针的位置                nums[i] = nums[j];            }        }        // 返回不重复元素的个数        return i + 1;    }}
  • i 是慢指针,j 是快指针。
  • 当 nums[i] = nums[j] 时,递增 j 以跳过重复项。
  • 当 nums[i] ≠ nums[j] 时,必须将其(nums[j] 的值)复制到 nums[i + 1]。然后递增 i,再将 j 的值复制到 i 的下一个位置,最后再递增 j。

力扣链接:https://leetcode.cn/problems/remove-duplicates-from-sorted-array/

一步一个脚印

不积跬步无以至千里,不积小流无以成江海。LeetCode - 100天从算法小白到卷王正式启动了,我们计划周一到周五至少每天更新一篇,周六周日更新一篇,目标 300 道 LeetCode 经典题。

该题解目前只针对**二哥编程星球 **的球友开放,如果你也想一起打卡学习算法的话,扫下面的优惠券加入我们吧,星球目前 4400+ 人,定价 149 元,从当初的 99 元一路涨上来的,所以早就是优势,别再犹豫了。

(优惠券仅 300 张,数量有限)

一个人可以走得很快,但一群人才能走得更远。如果想去面中大厂的话,LeetCode 几乎是必刷的,二哥的 LeetCode 题解通俗易懂、图文并茂,理解给你举一反三的解题能力,冲鸭。

今天夜游了珠江,广州塔的夜景还是很不错的,尤其是坐在三层,贵一点的体感和坐一楼完全不一样。这会写一道 LeetCode,再写一篇明天的文章,睡觉。技术派阅读地址:https://paicoding.com/column/7/26

  • 语雀专栏地址+密码可通过星球置顶帖查看:https://t.zsxq.com/15rEo9Pdu

  • 这道题可以说完全重写了,给出 2 道大家完全都能掌握的题解(双指针,数组基本操作)。

  • 增加代码注释,这样大家更容易看懂并掌握题解;

  • 增加参考资料,这样大家可以从零基础直接开刷,减轻新手刷题的阻力;

  • 增加手绘图,这样大家更容易理解解题思路;

  • 增加 ACM 输入输出,这样大家可以在 Intellij IDEA 中进行调试;

  • 增加题解模拟,这样大家可以根据题解模拟整个题解过程,看完会有一种“哦哦”恍然大悟的感觉;

  • 图片上传至 OSS 并配合 CDN,提升大家在技术派网站中的阅读体感。

  • 另外,这一版本会作为 PDF 的终稿随后在星球进行发布。

鲁迅说过,大年初二,人在广州,我仍然没有停止刷二哥的 LeetCode 刷题笔记,这是我对自己的交代,也是对你们的交代,我们一起加油!

题意

给你一个 非严格递增排列 的数组 nums ,请你 原地 删除重复出现的元素,使每个元素 只出现一次 ,返回删除后数组的新长度。元素的 相对顺序 应该保持 一致 。然后返回 nums 中唯一元素的个数。

考虑 nums 的唯一元素的数量为 k ,你需要做以下事情确保你的题解可以被通过:

  • 更改数组 nums ,使 nums 的前 k 个元素包含唯一元素,并按照它们最初在 nums 中出现的顺序排列。nums 的其余元素与 nums 的大小不重要。
  • 返回 k。

评判标准

系统会用下面的代码来测试你的题解:

int[] nums = [...]; // 输入数组

int k = removeDuplicates(nums); // 调用
assert k == expectedNums.length;for (int i = 0; i < k; i++) { assert nums[i] == expectedNums[i];}

如果所有断言都通过,那么您的题解将被 通过。

难度

简单

示例

输入:nums=[1,1,2]

解释:返回新数组的长度2,并且原数组nums的前两个元素被修改为1,2。不需要考虑数组中超出新长度后面的元素。
输入:nums=[0,0,1,1,1,2,2,3,3,4]输出:5,nums=[0,1,2,3,4]解释:方法应该返回新的长度5,并且原数组nums的前五个元素被修改为0,1,2,3,4。不需要考虑数组中超出新长度后面的元素。

分析

看完题目,我们要搞清楚几个事情:

  • 非严格递增排列
  • 原地删除重复出现的元素

非严格递增排序,其实就是传统意义上的升序排列,即nums[i] <= nums[i + 1]。只不过,确实是“非严格”,存在相等的情况,而不是 nums[i] < nums[i + 1]。

因为如果是严格递增排序的话,也就不存在重复元素了,😝

那什么是原地删除重复出现的元素呢?

"原地删除重复出现的元素"(In-place remove duplicates)是一种常见的算法策略,特别是在处理数组或线性数据结构时。

"原地"(In-place)操作意味着算法对数据的修改是直接在给定的数据结构上进行的,而不是使用额外的空间来创建数据的副本进行操作。

对于删除数组中的重复元素的操作来说,"原地"操作要求我们不使用额外的数组或集合来存储结果,而是直接在输入的数组上进行修改。

如果我们抛去原地操作这个限制,题解一般会这样写:

class Solution {
    int i = 0,j = 0;        // 创建一个新的数组        int[] res = new int[nums.length];        // 遍历原来的数组        for(;i < nums.length;i++) {            // 如果当前元素不等于下一个元素            if(nums[i] != nums[i + 1]) {                // 将当前元素放到新数组中                res[j++] = nums[i];            }        }        return j;    }

}

就 too simple 了!这道题也就没有存在的必要了。

那如何在原地进行修改呢?

其实也简单,我们用两个指针,一个指针 i 用来遍历数组,另一个指针 j 用来指向不重复的元素。

当 nums[i] 不等于 nums[j] 时,说明找到了一个新的不重复元素,此时将 j 指针向后移动一位,并将 nums[i] 的值复制到 nums[j]。这一步实际上是在更新当前不重复序列的下一个位置,并将新发现的不重复元素放在那里。

没错,就可以实现原地修改了!

class Solutions {
    int i = 0,j = 0;        for(;i < nums.length;i++)            if(nums[i] != nums[j])                nums[++j] = nums[i];        return j + 1;    }}

其实就是,把不重复的元素按照顺序放在数组的前面,然后返回不重复元素的个数,就搞定了。我们并没有关心 num 数组本身是什么样子。

比如说,nums = [0,0,1,1,1,2,2,3,3,4],nums 最后是 [0,1,2,3,4,2,2,3,3,4]。

大家可以通过 debug 的方式体验一下:

class Main02601 {
    Solutions02601 solutions = new Solutions02601();        int[] nums = {0,0,1,1,1,2,2,3,3,4};        int result = solutions.removeDuplicates(nums);        System.out.println(result);    }}

class Solutions02601 { public int removeDuplicates(int[] nums) { int i = 0,j = 0; for(;i < nums.length;i++) { if (nums[i] != nums[j]) { nums[++j] = nums[i]; } } return j + 1; }}

看一看是不是也很简单?效率也很不错。

总结

这道题其实没有考察别的东西,就是单纯的**数组 **操作,我们甚至可以换另外一种写法:

class Solution {
    // 如果数组为空,直接返回 0        if (nums.length == 0) return 0;        // 定义一个慢指针        int i = 0;        // j 为快指针,用来遍历数组        for (int j = 1; j < nums.length; j++) {            // 如果当前元素不等于下一个元素            if (nums[j] != nums[i]) {                // 移动慢指针                i++;                // 将当前元素复制到慢指针的位置                nums[i] = nums[j];            }        }        // 返回不重复元素的个数        return i + 1;    }}
  • i 是慢指针,j 是快指针。
  • 当 nums[i] = nums[j] 时,递增 j 以跳过重复项。
  • 当 nums[i] ≠ nums[j] 时,必须将其(nums[j] 的值)复制到 nums[i + 1]。然后递增 i,再将 j 的值复制到 i 的下一个位置,最后再递增 j。

力扣链接:https://leetcode.cn/problems/remove-duplicates-from-sorted-array/

一步一个脚印

不积跬步无以至千里,不积小流无以成江海。LeetCode - 100天从算法小白到卷王正式启动了,我们计划周一到周五至少每天更新一篇,周六周日更新一篇,目标 300 道 LeetCode 经典题。

该题解目前只针对**二哥编程星球 **的球友开放,如果你也想一起打卡学习算法的话,扫下面的优惠券加入我们吧,星球目前 4400+ 人,定价 149 元,从当初的 99 元一路涨上来的,所以早就是优势,别再犹豫了。

(优惠券仅 300 张,数量有限)

一个人可以走得很快,但一群人才能走得更远。如果想去面中大厂的话,LeetCode 几乎是必刷的,二哥的 LeetCode 题解通俗易懂、图文并茂,理解给你举一反三的解题能力,冲鸭。

今天夜游了珠江,广州塔的夜景还是很不错的,尤其是坐在三层,贵一点的体感和坐一楼完全不一样。这会写一道 LeetCode,再写一篇明天的文章,睡觉。技术派阅读地址:https://paicoding.com/column/7/26

  • 语雀专栏地址+密码可通过星球置顶帖查看:https://t.zsxq.com/15rEo9Pdu

  • 这道题可以说完全重写了,给出 2 道大家完全都能掌握的题解(双指针,数组基本操作)。

  • 增加代码注释,这样大家更容易看懂并掌握题解;

  • 增加参考资料,这样大家可以从零基础直接开刷,减轻新手刷题的阻力;

  • 增加手绘图,这样大家更容易理解解题思路;

  • 增加 ACM 输入输出,这样大家可以在 Intellij IDEA 中进行调试;

  • 增加题解模拟,这样大家可以根据题解模拟整个题解过程,看完会有一种“哦哦”恍然大悟的感觉;

  • 图片上传至 OSS 并配合 CDN,提升大家在技术派网站中的阅读体感。

  • 另外,这一版本会作为 PDF 的终稿随后在星球进行发布。

鲁迅说过,大年初二,人在广州,我仍然没有停止刷二哥的 LeetCode 刷题笔记,这是我对自己的交代,也是对你们的交代,我们一起加油!

题意

给你一个 非严格递增排列 的数组 nums ,请你 原地 删除重复出现的元素,使每个元素 只出现一次 ,返回删除后数组的新长度。元素的 相对顺序 应该保持 一致 。然后返回 nums 中唯一元素的个数。

考虑 nums 的唯一元素的数量为 k ,你需要做以下事情确保你的题解可以被通过:

  • 更改数组 nums ,使 nums 的前 k 个元素包含唯一元素,并按照它们最初在 nums 中出现的顺序排列。nums 的其余元素与 nums 的大小不重要。
  • 返回 k。

评判标准

系统会用下面的代码来测试你的题解:

int[] nums = [...]; // 输入数组

int k = removeDuplicates(nums); // 调用
assert k == expectedNums.length;for (int i = 0; i < k; i++) { assert nums[i] == expectedNums[i];}

如果所有断言都通过,那么您的题解将被 通过。

难度

简单

示例

输入:nums=[1,1,2]

解释:返回新数组的长度2,并且原数组nums的前两个元素被修改为1,2。不需要考虑数组中超出新长度后面的元素。
输入:nums=[0,0,1,1,1,2,2,3,3,4]输出:5,nums=[0,1,2,3,4]解释:方法应该返回新的长度5,并且原数组nums的前五个元素被修改为0,1,2,3,4。不需要考虑数组中超出新长度后面的元素。

分析

看完题目,我们要搞清楚几个事情:

  • 非严格递增排列
  • 原地删除重复出现的元素

非严格递增排序,其实就是传统意义上的升序排列,即nums[i] <= nums[i + 1]。只不过,确实是“非严格”,存在相等的情况,而不是 nums[i] < nums[i + 1]。

因为如果是严格递增排序的话,也就不存在重复元素了,😝

那什么是原地删除重复出现的元素呢?

"原地删除重复出现的元素"(In-place remove duplicates)是一种常见的算法策略,特别是在处理数组或线性数据结构时。

"原地"(In-place)操作意味着算法对数据的修改是直接在给定的数据结构上进行的,而不是使用额外的空间来创建数据的副本进行操作。

对于删除数组中的重复元素的操作来说,"原地"操作要求我们不使用额外的数组或集合来存储结果,而是直接在输入的数组上进行修改。

如果我们抛去原地操作这个限制,题解一般会这样写:

class Solution {
    int i = 0,j = 0;        // 创建一个新的数组        int[] res = new int[nums.length];        // 遍历原来的数组        for(;i < nums.length;i++) {            // 如果当前元素不等于下一个元素            if(nums[i] != nums[i + 1]) {                // 将当前元素放到新数组中                res[j++] = nums[i];            }        }        return j;    }

}

就 too simple 了!这道题也就没有存在的必要了。

那如何在原地进行修改呢?

其实也简单,我们用两个指针,一个指针 i 用来遍历数组,另一个指针 j 用来指向不重复的元素。

当 nums[i] 不等于 nums[j] 时,说明找到了一个新的不重复元素,此时将 j 指针向后移动一位,并将 nums[i] 的值复制到 nums[j]。这一步实际上是在更新当前不重复序列的下一个位置,并将新发现的不重复元素放在那里。

没错,就可以实现原地修改了!

class Solutions {
    int i = 0,j = 0;        for(;i < nums.length;i++)            if(nums[i] != nums[j])                nums[++j] = nums[i];        return j + 1;    }}

其实就是,把不重复的元素按照顺序放在数组的前面,然后返回不重复元素的个数,就搞定了。我们并没有关心 num 数组本身是什么样子。

比如说,nums = [0,0,1,1,1,2,2,3,3,4],nums 最后是 [0,1,2,3,4,2,2,3,3,4]。

大家可以通过 debug 的方式体验一下:

class Main02601 {
    Solutions02601 solutions = new Solutions02601();        int[] nums = {0,0,1,1,1,2,2,3,3,4};        int result = solutions.removeDuplicates(nums);        System.out.println(result);    }}

class Solutions02601 { public int removeDuplicates(int[] nums) { int i = 0,j = 0; for(;i < nums.length;i++) { if (nums[i] != nums[j]) { nums[++j] = nums[i]; } } return j + 1; }}

看一看是不是也很简单?效率也很不错。

总结

这道题其实没有考察别的东西,就是单纯的**数组 **操作,我们甚至可以换另外一种写法:

class Solution {
    // 如果数组为空,直接返回 0        if (nums.length == 0) return 0;        // 定义一个慢指针        int i = 0;        // j 为快指针,用来遍历数组        for (int j = 1; j < nums.length; j++) {            // 如果当前元素不等于下一个元素            if (nums[j] != nums[i]) {                // 移动慢指针                i++;                // 将当前元素复制到慢指针的位置                nums[i] = nums[j];            }        }        // 返回不重复元素的个数        return i + 1;    }}
  • i 是慢指针,j 是快指针。
  • 当 nums[i] = nums[j] 时,递增 j 以跳过重复项。
  • 当 nums[i] ≠ nums[j] 时,必须将其(nums[j] 的值)复制到 nums[i + 1]。然后递增 i,再将 j 的值复制到 i 的下一个位置,最后再递增 j。

力扣链接:https://leetcode.cn/problems/remove-duplicates-from-sorted-array/

一步一个脚印

不积跬步无以至千里,不积小流无以成江海。LeetCode - 100天从算法小白到卷王正式启动了,我们计划周一到周五至少每天更新一篇,周六周日更新一篇,目标 300 道 LeetCode 经典题。

该题解目前只针对**二哥编程星球 **的球友开放,如果你也想一起打卡学习算法的话,扫下面的优惠券加入我们吧,星球目前 4400+ 人,定价 149 元,从当初的 99 元一路涨上来的,所以早就是优势,别再犹豫了。

(优惠券仅 300 张,数量有限)

一个人可以走得很快,但一群人才能走得更远。如果想去面中大厂的话,LeetCode 几乎是必刷的,二哥的 LeetCode 题解通俗易懂、图文并茂,理解给你举一反三的解题能力,冲鸭。

            知识星球
            
    
    
        
        扫码加入星球
        查看更多优质内容
    
    https://wx.zsxq.com/mweb/views/joingroup/join_group.html?group_id=15522885221412
26. 删除有序数组中的重复项
https://clxhxhhr.top/posts/2451/
作者
clxstart
发布于
2026-09-19
许可协议
CC BY-NC-SA 4.0
评论
0 条
还没有评论,先写一条吧。